Imports Microsoft.VisualBasic
Imports System
Imports System.Windows

Namespace FlowDocumentApp.FlowDocuments
	Public Class Attached
        Private Shared ReadOnly IsItemsHostProperty As DependencyProperty = DependencyProperty.RegisterAttached("IsItemsHost", GetType(Boolean), GetType(Attached), New FrameworkPropertyMetadata(False, FrameworkPropertyMetadataOptions.NotDataBindable, AddressOf OnIsItemsHostChanged))
		Private Shared ReadOnly ItemsHostProperty As DependencyProperty = DependencyProperty.RegisterAttached("ItemsHost", GetType(FrameworkContentElement), GetType(Attached), New FrameworkPropertyMetadata(Nothing, FrameworkPropertyMetadataOptions.NotDataBindable))

		Public Shared Function GetIsItemsHost(ByVal target As DependencyObject) As Boolean
			Return CBool(target.GetValue(IsItemsHostProperty))
		End Function


		Public Shared Sub SetIsItemsHost(ByVal target As DependencyObject, ByVal value As Boolean)
			target.SetValue(IsItemsHostProperty, value)
		End Sub


		Private Shared Sub SetItemsHost(ByVal element As FrameworkContentElement)
			Dim parent As FrameworkContentElement = element
			Do While parent.Parent IsNot Nothing
				parent = CType(parent.Parent, FrameworkContentElement)
			Loop
			parent.SetValue(ItemsHostProperty, element)
		End Sub


		Public Shared Function GetItemsHost(ByVal dp As DependencyObject) As FrameworkContentElement
			Return CType(dp.GetValue(ItemsHostProperty), FrameworkContentElement)
		End Function

		Private Shared Sub OnIsItemsHostChanged(ByVal d As DependencyObject, ByVal e As DependencyPropertyChangedEventArgs)
			If CBool(e.NewValue) Then
				Dim element As FrameworkContentElement = CType(d, FrameworkContentElement)
				If element.IsInitialized Then
					SetItemsHost(element)
				Else
					AddHandler element.Initialized, AddressOf ItemsHost_Initialized
				End If
			End If
		End Sub

		Private Shared Sub ItemsHost_Initialized(ByVal sender As Object, ByVal e As EventArgs)
			Dim element As FrameworkContentElement = CType(sender, FrameworkContentElement)
			RemoveHandler element.Initialized, AddressOf ItemsHost_Initialized
			SetItemsHost(element)
		End Sub
	End Class
End Namespace
