Imports Microsoft.VisualBasic
Imports System.Windows
Imports System.Windows.Documents

Namespace FlowDocumentApp.FlowDocuments
	Public Class BlockTemplateContent
		Inherits Section
        Private Shared ReadOnly TemplateProperty As DependencyProperty = DependencyProperty.Register("Template", GetType(DataTemplate), GetType(BlockTemplateContent), New PropertyMetadata(AddressOf OnTemplateChanged))

		Public Property Template() As DataTemplate
			Get
				Return CType(GetValue(TemplateProperty), DataTemplate)
			End Get
			Set(ByVal value As DataTemplate)
				SetValue(TemplateProperty, value)
			End Set
		End Property


		Public Sub New()
			Helpers.FixupDataContext(Me)
			AddHandler Loaded, AddressOf BlockTemplateContent_Loaded
		End Sub


		Private Sub BlockTemplateContent_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			GenerateContent(Template)
		End Sub


		Private Sub GenerateContent(ByVal template As DataTemplate)
			Blocks.Clear()
			If template IsNot Nothing Then
				Dim element As FrameworkContentElement = Helpers.LoadDataTemplate(template)
				Blocks.Add(CType(element, Block))
			End If
		End Sub

		Private Sub OnTemplateChanged(ByVal dataTemplate As DataTemplate)
			GenerateContent(dataTemplate)
		End Sub


		Private Shared Sub OnTemplateChanged(ByVal d As DependencyObject, ByVal e As DependencyPropertyChangedEventArgs)
			CType(d, BlockTemplateContent).OnTemplateChanged(CType(e.NewValue, DataTemplate))
		End Sub
	End Class
End Namespace
